<template>
  <a-form v-if="!vdata.isAdd" ref="formRef" :model="vdata.currentConfig" layout="vertical" :rules="vdata.formRules">
    <a-divider orientation="left">
      <a-tag color="#FF4B33">扫码POS参数</a-tag>
    </a-divider>
    <a-row justify="space-between" type="flex">
      <a-col :span="24">
        <a-form-item label="appId" name="appId">
          <a-input v-model:value.trim="vdata.currentConfig.appId" placeholder="请输入appId" />
        </a-form-item>
      </a-col>
      <a-col :span="24">
        <a-form-item label="appSecret" name="appSecret">
          <a-textarea v-model:value="vdata.currentConfig.appSecret" :placeholder="vdata.encryptAppSecret ? vdata.encryptAppSecret : '请输入appSecret'" />
        </a-form-item>
      </a-col>
    </a-row>
  </a-form>
</template>

<script lang="ts" setup>
import {reactive, ref, defineExpose} from 'vue'
 
  // 当前的form
  const formRef = ref()

  const  vdata = reactive({
    isAdd: true, // 新增or修改标识
    // 配置对象
    currentConfig: {} as any,
    encryptAppSecret: '',
    // 表单规则
    formRules: {
      appId: [{ required: true, message: '请输入appId', trigger: 'blur' }]
    }
  })

  // 对外提供的页面的渲染函数 （ ifDefineArray = 接口的配置定义项数组，  currentConfig = 当前配置项 ）
function pageRender(currentConfig: any, isAdd: boolean){
  // 赋值
  vdata.currentConfig = currentConfig
  vdata.encryptAppSecret = currentConfig.appSecret
  vdata.currentConfig.appSecret = ''
  vdata.isAdd = isAdd

  // 重置form验证
  if (formRef.value !== undefined && formRef.value !== null) {
    formRef.value.resetFields()
  }
}

// 对外提供的获取配置参数函数 （返回JSON类型）
function getConfigParams(){

   // 重置form验证
  if (formRef.value !== undefined && formRef.value !== null) {
    return formRef.value.validate().then( () => {
      return vdata.currentConfig
    })
  }else{
    return Promise.resolve()
  }

 
}

defineExpose({ getConfigParams, pageRender })

</script>
